/*
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _TYPEDEF_H_
#define _TYPEDEF_H_

#include <arpa/inet.h>

#include "have_config.h"
#include "config.h"

#ifdef HAVE_SSLLIB
#include <openssl/ssl.h>
#endif /* HAVE_SSLLIB */

enum err_prog
  {
    err_no_argv,
    err_mem_alloc,
    err_no_lib_mysql,
    err_no_lib_ssh,
    err_no_lib_ssl,
    err_port,
    err_no_write_proto,
    err_strtol,
    err_ip_unknow,
    err_ip_invalid,
    err_protocol_unknow,
    signal_exit
  };

/*
 * inutile , mais je le garde au cas ou ... toujours utile pour
 * savoir exatcement ce qui a echoué dans une connection
 */
enum err_proto_e
  {
    proto_no_err = 0,
    err_proto_socket = -1,
    err_proto_no_ssl = -2,
    err_proto_connect_ssl = -3, 
    err_proto_acceuil = -4,
    err_proto_login = -5,
    err_proto_passwd = -6
  };

struct proto_s
  {
    char *name;
    char *login;
    char *passwd;
    int port;
  };

struct th_argv_s
  {
    int index;
    char ip[IPv4_SIZE];
  };

struct pasv_s
  {
    char ip[IPv4_SIZE];
    int tab[2];
    int port;
  };

struct pile_s
  {
    char ip[IPv4_SIZE];
    char *permission;
    struct pile_s *next;
  };

struct socket_s
  {
    int socket;
    struct sockaddr_in to;
#ifdef HAVE_SSLLIB
    SSL *ssl;
#endif /* HAVE_SSLLIB */
  };

struct stat_s
  {
    int n_ip;
    int n_open;
    int n_found;
    time_t start;
    time_t stop;
  };

struct opt_s
  {
    char *proto;
    char *login;
    char *passwd;
    char ip_cur[IPv4_SIZE];
    char ip_end[IPv4_SIZE];
    int log;
    int port;
    int verbose;
    int timeout;
    int n_thread;
    int ssl;
    int get_ftp_write;
  };

#endif /* _TYPEDEF_H_ */
