/*
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include "typedef.h"
#include "prototype.h"
#include "global.h"
#include "have_config.h"

void
exit_program (int code)
{
  switch (code)
    {
  case err_no_argv:
    fprintf (stderr, "argument not specified.\n");
    break;
  case err_port:
    fprintf (stderr, "port invalid.\n");
    break;
  case err_ip_unknow:
    fprintf (stderr, "ip unknow.\n");
    break;
  case err_ip_invalid:
    fprintf (stderr, "format ip invalid.\n");
    break;
  case err_protocol_unknow:
    fprintf (stderr, "protocol not specified.\n");
    break;
  case err_mem_alloc:
    fprintf (stderr, "virtual memory exhausted.\n");
    break;
  case signal_exit:
    fprintf (stderr, "signal recved exit program.\n");
    break;
  case err_no_write_proto:
    fprintf (stderr, "option -w invalid you must choose protocol ftp or ftps with option -w.\n");
    break;
  case err_no_lib_mysql:
    fprintf (stderr, "you are not lib mysqlclient. install and recompile program for use protocole mysql\n");
    break;
  case err_no_lib_ssh:
    fprintf (stderr, "you are not lib ssh. install and recompile program for use protocole ssh\n");
    break;
  case err_no_lib_ssl:
    fprintf (stderr, "you are not lib openssl. install and recompile program for use SSL\n");
    break;
    }

  clean_memory ();
  exit(code);
}
