/*
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "have_config.h"
#ifdef HAVE_MYSQLLIB

#include <mysql/mysql.h>
#include <stdlib.h>

#include "typedef.h"
#include "global.h"
#include "prototype.h"

int
nsa_mysql_connect (const int index)
{
  MYSQL mysql;
  MYSQL *connect = NULL;
  unsigned int timeout;

  mysql_init(&mysql);
  timeout = p_opt->timeout;
  if (!mysql_options(&mysql, MYSQL_OPT_CONNECT_TIMEOUT, (char*)&timeout))
    {
      connect = mysql_real_connect(&mysql, th_argv[index]->ip, p_opt->login,
                              p_opt->passwd, NULL, p_opt->port, NULL, 0);
    }

  mysql_close(&mysql);
  return (!connect) ? -1 : 0;
}
#endif  /* HAVE_MYSQLLIB */
