/*
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <string.h>
#include <stdio.h>

#include "global.h"
#include "config.h"
#include "prototype.h"

int
nsa_pop3_connect (struct socket_s *socket)
{
#ifdef HAVE_SSLLIB
  if (p_opt->ssl)
    {
      socket->ssl = connect_ssl(socket->socket);
      if (!socket->ssl)
        return err_proto_connect_ssl;
    }
#endif /* HAVE_SSLLIB */
  if (cmd_check_code (socket, POP3_CMD_SUCCESS) == -1)
    return err_proto_acceuil;

  if (cmd_send (socket, "USER ", p_opt->login, "\r\n", NULL) == -1)
    return err_proto_socket;

  if (cmd_check_code (socket, POP3_CMD_SUCCESS) == -1)
    return err_proto_login;

  if (cmd_send (socket, "PASS ", p_opt->passwd, "\r\n", NULL) == -1)
    return err_proto_socket;

  if (cmd_check_code (socket, POP3_CMD_SUCCESS) == -1)
    return err_proto_passwd;

  return proto_no_err;
}
