/*
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <time.h>

#include "prototype.h"
#include "typedef.h"
#include "global.h"

void
print_version (void)
{
  printf("\r\n\tNullSearchAccess"
        "\r\n\tversion 1.1\n\n");
}

void
print_help (void)
{
  printf("Help menu :\n"
    "\r\t-h\r\t\t : print help menu\n"
    "\r\t-m\r\t\t : protocole (ftp, pop, imap, mysql)\n"
    "\r\t-b\r\t\t : ip start\n"
    "\r\t-e\r\t\t : ip end\n"
    "\r\t-p\r\t\t : port (default 21)\n"
    "\r\t-t\r\t\t : timeout (default 3s)\n"
    "\r\t-n\r\t\t : thread numbers (default 100)\n"
    "\r\t-l\r\t\t : login (default anonymous)\n"
    "\r\t-a\r\t\t : passwd (default anonymous)\n"
    "\r\t-v\r\t\t : verbose mode\n"
    "\r\t-d\r\t\t : debug mode\n"
    "\r\t-f\r\t\t : write result in file (NULLSearch.txt)\n"
    "\r\t-w\r\t\t : print permission of current directory (for protocol ftp or ftps)\n");
                  
}

void
print_verbose_argv (void)
{
  printf("[verbose] -> port :%d\n[verbose] -> login :%s\n[verbose] -> passwd :%s\n"
    "[verbose] -> ip start :%s\n[verbose] -> ip end :%s\n[verbose] -> thread numbers :%d\n"
    "[verbose] -> timeout :%d\n[verbose] -> proto :%s\n", p_opt->port, p_opt->login,
     p_opt->passwd, p_opt->ip_cur,p_opt->ip_end, p_opt->n_thread, p_opt->timeout, p_opt->proto);
  if (p_opt->log)
    printf("[verbose] -> log :OK\n");
}

void
print_started (void)
{
  printf("... scan started ...\n"
    "... CTRL+C to stoped\n"
    "... CTRL+\\ for info\n");
}

void
print_static (void)
{
  struct pile_s *p_pile = pile;

  if (pile)
    {
      printf("\rIP\r\t\tPORT");
      if (p_opt->get_ftp_write)
        printf("\r\t\t\tPERM: \r\t\t\t\tUSER  GROUP  OTHER");
      while (p_pile)
        {
          printf("\n%s\r\t\t%d", p_pile->ip, p_opt->port);
          if (p_opt->get_ftp_write)
            {
              printf("\r\t\t\t\t");
              printf("%c%c%c   %c%c%c    %c%c%c",
                *(pile->permission+1), *(pile->permission+2), *(pile->permission+3),
                *(pile->permission+4), *(pile->permission+5), *(pile->permission+6),
                *(pile->permission+7), *(pile->permission+8), *(pile->permission+9));
            }
          p_pile = p_pile->next;
        }
    }
  else
    printf("\nNot ip found.\n");

  printf("\nSTATISTIQUE : \n- scanned : %d\n- open port : %d\n- ip accept null session : %d\n- in : %d second(s)\n",
         p_stt->n_ip, p_stt->n_open, p_stt->n_found, (int)(p_stt->stop - p_stt->start));
}

void
print_static_current (void)
{
  p_stt->stop = time (NULL);
  printf("ip scanned: %d | open port: %d | nb found: %d | current ip: %s | time: %lds\n",
    p_stt->n_ip, p_stt->n_open, p_stt->n_found, scanned_current_ip, (p_stt->stop-p_stt->start));
}