/*
 *    This file is part of NSA ( NullSearchAccess ).
 *
 *  NSA ( NullSearchAccess ) is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  NSA ( NullSearchAccess ) is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NSA ( NullSearchAccess ).  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "have_config.h"
#ifdef HAVE_SSHLIB

#include <string.h>
#include <stdio.h>
#include <libssh/libssh.h>

#include "typedef.h"
#include "global.h"
#include "prototype.h"

int
nsa_ssh_connect (const int index)
{
  int ret;
  SSH_SESSION *session = NULL;
  SSH_OPTIONS *options = NULL;

  ret = -1;
  options = ssh_options_new();
  if (!options)
    return -1;

  session = ssh_new();
  if (session)
    {
      ssh_options_set_username(options, p_opt->login);
      ssh_options_set_host(options, th_argv[index]->ip);
      ssh_options_set_port(options, p_opt->port);

      ssh_set_options(session, options);
      if (ssh_connect(session) != -1)
        ret = ssh_userauth_password(session, p_opt->login, p_opt->passwd);
    }

  ssh_disconnect(session);
  return ret;
}
#endif /* HAVE_SSHLIB */